workflow:
  rules:
    - if: $CI_COMMIT_BRANCH == "main" || $CI_PIPELINE_SOURCE == "merge_request_event" # Only run for the main branch and merge requests
      when: always
    - when: never # Never run for other branches

stages:
  - test
  - build
  - deploy

run_unit_tests:
  stage: test
  script:
    - echo "Running unit Tests for $MICRO_SERVICE_NAME"

run_lint_tests:
  stage: test
  script:
    - echo "Running lint Tests for $MICRO_SERVICE_NAME"

build_image:
  stage: build
  script:
    - echo "Building the Docker Image"
  rules:
    - if: $CI_COMMIT_BRANCH == "main" # Run only for the main branch

push_image:
  stage: build
  needs:
    - build_image
  script:
    - echo "Pushing the Docker Image to the Registry"
  rules:
    - if: $CI_COMMIT_BRANCH == "main" # Run only for the main branch

deploy_image:
  stage: deploy
  script:
    - echo "Deploying the Docker Image to the env  -> $DEPLOYMENT_ENV"
  rules:
    - if: $CI_COMMIT_BRANCH == "main" # Run only for the main branch
